// 获取首页的top栏目

import { baseUrl } from '../constants.ts';
import axios from 'axios';
import * as cheerio from 'cheerio';
import * as puppeteer from 'puppeteer';
import fs from 'fs';
import path from 'path';
import { fileURLToPath } from 'url';
import jsdom from 'jsdom';

// 调用函数
// fetchPageContent();

const element = `<div class="banner">
				<ul class="bannerList fix" id="bannerList"><li class="bannerCho on"><h2><a href="/" target="_blank">日经精选</a></h2><div><ul class="fix" style="width:980"><li><a href="/top/nian-du-pan-dian-zhan-wang.html" target="_blank">年度盘点展望</a></li><li><a href="/top/2021-04-20-01-47-39.html" target="_blank">日本企业研究</a></li><li><a href="/top/2020-08-25-06-34-55.html?types[0]=8" target="_blank">半导体/AI</a></li><li><a href="/top/2019-08-29-06-18-57.html" target="_blank">中日深度观察</a></li><li><a href="/top/201604-3.html" target="_blank">日本游</a></li><li><a href="/top/2021-03-03-07-02-53.html?types[0]=8" target="_blank">脱碳经济</a></li><li><a href="/top/bp.html?types[0]=8" target="_blank">日经BP精选</a></li><li><a href="/top/ft.html?types[0]=8" target="_blank">FT中文网精选</a></li><li class="end"><a href="/top/foa2024.html?types[0]=8" target="_blank">亚洲的未来</a></li></ul></div></li><li class="bannerChi"><h2><a href="/china.html" target="_blank">中国</a></h2><div><ul class="fix" style="width:980"><li><a href="/china/ceconomy.html" target="_blank">经济</a></li><li><a href="/china/ccompany.html" target="_blank">企业</a></li><li><a href="/china/cfinancial.html" target="_blank">金融市场</a></li><li class="end"><a href="/china/cpolicssociety.html" target="_blank">政治/社会</a></li></ul></div></li><li class="bannerObs"><h2><a href="/politicsaeconomy.html" target="_blank">政经观察</a></h2><div><ul class="fix" style="width:980"><li><a href="/politicsaeconomy/epolitics.html" target="_blank">宏观经济</a></li><li><a href="/politicsaeconomy/economic-policy.html" target="_blank">经济政策</a></li><li><a href="/politicsaeconomy/stockforex.html" target="_blank">股市/外汇</a></li><li><a href="/politicsaeconomy/investtrade.html" target="_blank">投资/贸易</a></li><li><a href="/politicsaeconomy/efinance.html" target="_blank">金融</a></li><li><a href="/politicsaeconomy/commodity.html" target="_blank">大宗商品</a></li><li class="end"><a href="/politicsaeconomy/politicsasociety.html" target="_blank">政治/社会</a></li></ul></div></li><li class="bannerInd"><h2><a href="/industry.html" target="_blank">产业聚焦</a></h2><div><ul class="fix" style="width:980"><li><a href="/industry/icar.html" target="_blank">汽车</a></li><li><a href="/industry/itelectric-appliance.html" target="_blank">IT/家电</a></li><li><a href="/industry/ienvironment.html" target="_blank">环境/能源</a></li><li><a href="/industry/manufacturing.html" target="_blank">工业</a></li><li><a href="/industry/agriculture.html" target="_blank">农林水产</a></li><li><a href="/industry/propertiesconstruction.html" target="_blank">地产/建设</a></li><li><a href="/industry/tradingretail.html" target="_blank">商业/消费</a></li><li><a href="/industry/scienceatechnology.html" target="_blank">科学/技术</a></li><li class="end"><a href="/industry/management-strategy.html" target="_blank">经营/战略</a></li></ul></div></li><li class="bannerNpr"><h2><a href="/product.html" target="_blank">新产品</a></h2><div><ul class="fix" style="width:980"><li><a href="/product/pdigital.html" target="_blank">数码与家电</a></li><li><a href="/product/automobile.html" target="_blank">汽车</a></li><li><a href="/product/beautyahealth.html" target="_blank">美容与健康</a></li><li><a href="/product/prime-goods.html" target="_blank">美品精选</a></li><li class="end"><a href="/product/joke-goods.html" target="_blank">非凡创意</a></li></ul></div></li><li class="bannerCjp"><h2><a href="/trend.html" target="_blank">穿梭日本</a></h2><div><ul class="fix" style="width:980"><li><a href="/trend/cool-japan.html" target="_blank">酷日本</a></li><li><a href="/trend/beautyahealth.html" target="_blank">美容健身</a></li><li><a href="/trend/traditional-culture.html" target="_blank">文化精粹</a></li><li class="end"><a href="/trend/tourism.html" target="_blank">日本逍遥行</a></li></ul></div></li><li class="bannerPoi"><h2><a href="/columnviewpoint.html" target="_blank">专栏/观点</a></h2><div><ul class="fix" style="width:980"><li><a href="/columnviewpoint/tearoom.html" target="_blank">中日茶坊</a></li><li><a href="/columnviewpoint/columns-b.html" target="_blank">肖敏捷论中日</a></li><li><a href="/columnviewpoint/column-special1.html" target="_blank">日本人小声说</a></li><li><a href="/columnviewpoint/liudicolumn.html" target="_blank">刘迪观察</a></li><li><a href="/columnviewpoint/zhangshicolumn.html" target="_blank">张石的樱雪鸿泥</a></li><li><a href="/columnviewpoint/kelongcolumn.html" target="_blank">老柯要说话</a></li><li><a href="/columnviewpoint/criticism.html" target="_blank">社评</a></li><li><a href="/columnviewpoint/viewpoint.html" target="_blank">观点</a></li><li class="end"><a href="/columnviewpoint/column.html" target="_blank">专栏</a></li></ul></div></li><li class="bannerJob"><h2><a href="/career.html" target="_blank">职场/深造</a></h2><div><ul class="fix" style="width:980"><li><a href="/career/humanresource.html" target="_blank">人才活用</a></li><li><a href="/career/employment.html" target="_blank">就业</a></li><li class="end"><a href="/career/abroadstudy.html" target="_blank">留学/教育</a></li></ul></div></li></ul>
			</div>`;

const dom = new jsdom.JSDOM(element);
const bannerList = dom.window.document.getElementById('bannerList');
const liList = bannerList?.children;

// Convert HTMLCollection to an array before using forEach
const linksArray: Link[] = [];
Array.from(liList).forEach((li) => {
  const children: { href: string; text: string }[] = [];
  const h2 = li.querySelector('h2 a');
  const text = h2?.textContent;
  const href = h2?.getAttribute('href');

  const ul = li.querySelector('ul');
  const ulList = ul.children;
  Array.from(ulList).forEach((ul) => {
    const a = ul.children[0] as HTMLAnchorElement;
    const href = a.getAttribute('href');
    const text = a.textContent;
    children.push({ href, text });
  });
  linksArray.push({ name: text, href, children });
});

// 定义链接类型
type Link = {
  name: string;
  href?: string;
  children: {
    href: string;
    text: string;
  }[];
};

// 输出结果，或者进行其他处理
// console.log(JSON.stringify(linksArray));
const __filename = fileURLToPath(import.meta.url);
const __dirname = path.dirname(__filename);
// 当前文件相对路径，使用import
fs.writeFileSync(path.join(__dirname, 'tabs.json'), JSON.stringify(linksArray, null, 2));
